% HCFFT NHCFFT and LHCFFT Files
% ----------------------
%
% m-Files:
%   hcdft              - Computes hyperbolic cross dft and its adjoint
%   hcfft              - Computes the HCFFT its adjoint, inverse, and adjoint inverse
%   hcfft_coordhc      - Computes the coordinates of a hyperbolic cross of dimension d and level n
%   hcfft_coordsg      - Computes the coordinates of a sparse grid of dimension d and level n
%   hcfft_hc2vec       - Converts a hc tensor in a hc vector in order of the indexing function
%   hcfft_index        - indexing function - rule of ordering a hc or sg in an array
%   hcfft_initialize   - Computes matrices used for the indexing function for grids of dimension d and level n
%   hcfft_sg2vec       - Converts sg tensor to sg vector in order of the indexing function
%   hcfft_times        - Tests computational time of HCFFT and HCDFT
%   hcfft_vec2hc       - Converts hc vector B to hc sparse tensor A.
%   hcfft_vec2sg       - Converts sg vector B to sg sparse tensor C.
%   lhcfft             - Computes trigonometric polynomials with given Fourier coefficients at the hyperbolic cross at lattice nodes
%   lhcfft_init        - loads nonaliasing lattice for given problem size from lhcfft_init_data.mat
%   lhcfft_plot        - organizes double-logarithmic computational time plots
%   lhcfft_search      - searches for nonaliasing rank-1 lattices of given type
%   lhcfft_simple_test - simple example of lhcfft
%   lhcfft_times       - Tests and compares computational time of LHCFFT, HCFFT and HCDFT
%   nhcdft             - Computes nonequispaced hyperbolic cross dft and its adjoint
%   nhcfft             - Computes NHCFFT and aNHCFFT in 2d and 3d
%   nhcfft_bool_int    - Interpolation of values on vector T containing a sg with periodic splines of order m
%   nhcfft_bool_val    - Computes interpolated function values at any points x in 1d, 2d or 3d.
%   nhcfft_error       - Tests relative error of NHCFFT with respect to spline order
%   nhcfft_simple_test - simple examples of hcfft and nhcfft
%   nhcfft_times       - Tests computational times of NHCDFT, NHCFFT and its three steps
%
% mat-Files:
%   lhcfft_init_data   - Saved nonalising lattices of different types for several problem sizes