function ind=hcfft_index(l, q, d, n, in)
% indexing function - rule of ordering a hc or sg in an array
%
% Copyright 2009 (c) Michael Doehler, Lutz Kaemmerer, Stefan Kunis, Daniel Potts
%
% $Id: hcfft_index.m 1102 2010-07-08 14:29:25Z kaemmerer $

    if (n==0)
        ind=1;
        return;
    end
    %determination of zeros in l
    a=[0 0];
    k=0;    %number of zeros in l
    j=0;    %number of non-zeros in l
    l1=0;   %will contain l without zeros
    q1=0;   %will contain q without zeros
    for i=1:d
        if(l(i)==0)
            k=k+1;
            a(k+1)=i;
        else
            j=j+1;
            l1(j)=l(i);
            q1(j)=q(i);
        end
    end
    
    komb=0; %index of combination of k zeros in l
    for i=1:k
        komb=komb+sum(in.bino(d-a(i+1)+1:d-a(i)-1,k-i+1));
    end

    [rl si] = lind(l1, q1, d-k, in.P);
    ind = in.s(d,n) + in.bino(d, 1:k)*in.g(d:-1:d-k+1, n) + komb*in.g(d-k, n) + rl*2^(n-d+k) + si + 1;
end


function [ rl si ] = lind( l, q, d, P )
%finds an index rl of level l within |l|=const
%finds an index si of index q within level l (q consists only of odd
%numbers)
%none of the l_i or q_i must be 0

    rl=0;
    si=0;
    n1=1;
    d1=0;
    for m=d:-1:2
        d1=d1+1;
        n1=n1+l(m)-1;
        rl=rl+P(n1,d1);
        si=(q(m)-1)/2 + 2^(l(m)-1)*si;
    end
    si=(q(1)-1)/2 + 2^(l(1)-1)*si;
end

