function in=hcfft_initialize(d, n)
% Computes matrices used for the indexing function for grids of dimension d and level n
%
% in = hcfft_initialize(d,n)
%
% d     = dimension
% n     = level (size) of grids
%
% Copyright 2009 (c) Michael Doehler, Lutz Kaemmerer, Stefan Kunis, Daniel Potts
%
% $Id: hcfft_initialize.m 1102 2010-07-08 14:29:25Z kaemmerer $

    in.s=zeros(d,n+1);
    in.s(1,1:n+1)=2.^(0:n);
    for m=2:d
        for k=0:n
            in.s(m,k+1) = sum(2.^(0:k-1).*in.s(m-1,k:-1:1)) + in.s(m-1,k+1);
        end
    end
    %|S^d_n| = s(d, n+1)

    in.g=zeros(d,n);
    in.g(1,1:n)=2.^(0:n-1);
    for m=2:d
        for k=m:n
            in.g(m,k) = sum(2.^(0:k-m).*in.g(m-1,k-1:-1:(m-1)));
        end
    end
    %|\tilde S^d_n| = g(d, n)

    in.P=zeros(n+1,d);
    in.P(2:n+1,1)=1:n;
    for m=2:d
        for k=2:n+1
            in.P(k,m)=in.P(k-1,m) + in.P(k,m-1);
        end
    end
    
    in.bino=zeros(d, d+1);
    for i=1:d
        for j=1:i+1
            in.bino(i,j)=nchoosek(i,j-1);
        end
    end
    %(a ber b) = bino(a, b+1)   (a=1..d, b=1..a)

end

