function lhcfft_plot(x,y,xtickpos,xulabel,xolabel,xlabel,xtlabel,fname)
%
% lhcfft_plot(x,y,xtickpos,xulabel,xolabel,xlabel,xtlabel,fname)
%
% function to organize plots; called by lhcfft_times
%
% Copyright 2010 (c) Michael Doehler, Lutz Kaemmerer, Stefan Kunis, Daniel Potts
%
% $Id: lhcfft_plot.m 1102 2010-07-08 14:29:25Z kaemmerer $

    fsleg=20;
    fsx=15;
    fsy=15;
    
    if(size(x,1)<15)
        lw=3;
        ms=12;
    else
        lw=1;
        ms=6;
    end
    
    figure(1);
    ax=axes;

   if size(x)~=size(y)
       disp('Problem');
       return;
   end
   
   lst={'--',':','-.'};
   mst={'x','+','o'};
   
   for j=1:size(x,2)
       li(j)=line(x(:,j),y(:,j),'Color','k','LineStyle',lst{j},'LineWidth',lw, 'Marker',mst{j},'MarkerSize',ms);
   end

   axis(ax,[1/2*min(min(x)),2*max(max(x)),1/2*min(min(y)),2*max(max(y))]);
   set(gca,'XTick',xtickpos);
   set(gca,'XTickLabel',[]);
   set(gca, 'XScale','log');
   set(gca, 'YScale','log');
   set(gca, 'XMinorTick','off');
   set(gca, 'YMinorTick','on');
   
   
   minY=min(get(gca,'YLim'));
   maxY=max(get(gca,'YLim'));
   minX=min(get(gca,'XLim'));
   maxX=max(get(gca,'XLim'));
   
   %maxY/minY
   for j=1:length(xolabel)
%      xol(j) = text('String',sprintf('%2.1e',xolabel{j}), ...
      xol(j) = text('String',xolabel{j}, ...
        'Units','data', ...
        'VerticalAlignment', 'bottom', ...
        'HorizontalAlignment', 'center', ...
        'Position',[xtickpos(j) maxY*(maxY/minY)^0.005], ...
        'Tag','MoXTL',...
        'FontSize',fsx);
      xul(j) = text('String',xulabel{j}, ...
        'Units','data', ...
        'VerticalAlignment', 'top', ...
        'HorizontalAlignment', 'center', ...
        'Position',[xtickpos(j) minY*(minY/maxY)^0.01], ...
        'Tag','MUXTL',...
        'FontSize',fsx);
   end
   
   
   text('String','M', ...
        'Units','data', ...
        'VerticalAlignment', 'bottom', ...
        'HorizontalAlignment', 'center', ...
        'Position',[maxX*(maxX/minX)^0.05 maxY*(maxY/minY)^0.005], ...
        'Tag','XLO',...
        'FontSize',fsx);
   text('String',xtlabel, ...
        'Units','data', ...
        'VerticalAlignment', 'top', ...
        'HorizontalAlignment', 'center', ...
        'Position',[maxX*(maxX/minX)^0.05 minY*(minY/maxY)^0.01], ...
        'Tag','XL', ...
        'FontSize',fsx);
   % damit die Bilder gleich groß werden, unabhängig von d ein- oder
   % zweistellig
   text('String','{}', ...
        'Units','data', ...
        'VerticalAlignment', 'top', ...
        'HorizontalAlignment', 'right', ...
        'Position',[maxX*(maxX/minX)^0.1 minY*(minY/maxY)^0.01], ...
        'Tag','XL', ...
        'FontSize',fsx);
   xlab=text('String',xlabel, ...
        'Units','data', ...
        'VerticalAlignment', 'top', ...
        'HorizontalAlignment', 'center', ...
        'Position',[exp((log(maxX)-log(minX))/2+log(minX)), minY/(maxY/minY).^0.2], ...
        'Tag','XL', ...
        'FontSize',fsx);

    
    
   ylabel('computational time in seconds','FontSize',fsy);
   
   if(size(x,2)==2)
       leg=legend('LHCFFT','HCFFT','Location','NorthWest');
   else
       leg=legend('LHCFFT','HCFFT','HCDFT','Location','NorthWest');
   end
   set(leg,'FontSize',fsleg,'FontWeight','bold');
   ppos=get(gca, 'Position');
   set(gca, 'Position',[ppos(1),0.2,ppos(3),0.75]);



    set(gca, 'box', 'on');
    set(ax,'FontSize',fsy);
    
    print(gcf, '-deps', fname);
end