% simple example of lhcfft, hcfft and nhcdft
%
% Copyright 2010 (c) Michael Doehler, Lutz Kaemmerer, Stefan Kunis, Daniel Potts
%
% $Id: lhcfft_simple_test.m 1102 2010-07-08 14:29:25Z kaemmerer $


clear all;
clc;

d=3;
n=7;

disp('********************************************************************************');
fprintf('simple test of lhcfft over hyperbolic cross of dimension d=%d and refinement n=%d\n',[d,n]);
in = hcfft_initialize(d,n);
D=in.s(d,n+1);
fhat=rand(D,1)-1/2+1i*(rand(D,1)-1/2);
tic;
f=hcfft(fhat,'notransp','noinv',in);
t=toc;
fprintf('duration of hcfft(fhat,''notransp'',''noinv'',[%d,%d]):             \t%d\n',[d,n,t]);

fprintf('lhcfft_init(%d,%d,''min'') returns\n',[d,n]);
[H,z,M]=lhcfft_init(d,n,'min');
sstring='\t1.\tindex matrix H=hcfft_coordhc(d,n) of size [%d,%d]\n\t2.\tgenerating vector z=[';
for j=1:d-1
    sstring=[sstring,'%d,'];
end
sstring=[sstring,'%d]\n\t3.\tlattice size M=%d of nonaliasing lattice\n'];
fprintf(sstring,[size(H),z,M]);
tic;
fl=lhcfft(H,z,M,fhat,'notransp');
t=toc;
fprintf('duration of lhcfft(H,z,M,fhat,''notransp''):                  \t%d\n',[t]);
%alpha=3;
%m=12;
tic;
fn=nhcdft(fhat,mod((0:M-1)'*z./M,1),'notransp',[d,n]);
t=toc;
fprintf('duration of nhcdft(fhat,mod((0:M-1)''*z./M,1),''notransp'',[%d,%d]):\t%d\n',[d,n,t]);
fprintf('-------------------------------------------\n');
fprintf('max(abs(lhcfft(H,z,M,A)-nhcdft(A,x)))/sum(abs(A)):            \t%d\n',max(abs(fl-fn))/sum(abs(fhat)));
disp('********************************************************************************');
d=54;
fprintf('simple test of lhcfft over hyperbolic cross of dimension d=%d and refinement n=%d\n',[d,n]);
fprintf('lhcfft_init(%d,%d,''min'') returns\n',[d,n]);
wsb=warning('QUERY','lhcfft_init:NoSuchLattice');
warning('ON', 'lhcfft_init:NoSuchLattice');
[H,z,M]=lhcfft_init(d,n,'min');
warning (wsb);
sstring='\t1.\tindex matrix H=zeros(1,%d)\n\t2.\tgenerating vector z=zeros(1,%d)';
sstring=[sstring,'\n\t3.\tlattice size M=0\n'];
fprintf(sstring,[d,d]);
disp('********************************************************************************');
clear;